/* RCS $Id: j_coth.c,v 1.3 1998/03/19 11:02:33 ae13 Exp $ */
/*
$Log: j_coth.c,v $
Revision 1.3  1998/03/19 11:02:33  ae13
change comment

Revision 1.2  1997/07/15 14:57:04  ae13
*** empty log message ***

 * Revision 1.1  1997/05/16  13:26:20  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_coth(a_intv x)               */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of tanh(x)      */
/*                                                              */
/*      Description     : Fast interval hyperbolic cotangent    */
/*                        function for double IEEE              */
/*                        Floating-Point Arithmetic             */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_coth(a_intv x)
#else
local a_intv j_coth(x)

a_intv x;
#endif
{
 a_intv res;

 if (x.SUP<0)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_coth(x.INF);
      res.SUP=res.INF*q_cthm;
      res.INF*=q_cthp;
    }
   else
    {
      res.INF=q_coth(x.SUP)*q_cthp;
      res.SUP=q_coth(x.INF)*q_cthm;
    } 
   if (res.SUP>-1) res.SUP=-1.0;
 }    /* end  if (x.SUP<0) */
 else if(x.INF>0)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_coth(x.INF);
      res.SUP=res.INF*q_cthp;
      res.INF*=q_cthm;
    }
   else
    {
      res.INF=q_coth(x.SUP)*q_cthm;
      res.SUP=q_coth(x.INF)*q_cthp;
    }  
   if (res.INF<1) res.INF=1.0;
 }
 else   /* invalid argument */
 {
#ifdef PXSCTRAP
   E_SPUSH("j_coth");
#endif
   res=q_abortr2(INV_ARG,&x.INF,&x.SUP,21);
#ifdef PXSCTRAP   
   E_SPOPP("j_coth");
#endif
 }
 return(res);
}

